package Jbroker;

/**
 * Aktie object used for HashMap (connected to a ComboBox)
 * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
 */
public class JbAktie {

    private String Name;
    private int WKN = -1;
    private double AktKurs;
    private double MinKurs;
    private double MaxKurs;
    private double Volumen;

    /**
     * Empty constructor
     */
    public JbAktie() {
    }

    /**
     * Constructor
     */
    public JbAktie(String Name, String WKN, String AktKurs, String MinKurs, String MaxKurs, String Volumen) {
	createJbAktie(Name, new Integer(WKN.trim()).intValue(),
		      new Double(AktKurs.trim()).doubleValue(), new Double(MinKurs.trim()).doubleValue(),
		      new Double(MaxKurs.trim()).doubleValue(), new Double(Volumen.trim()).doubleValue());
    }

    /**
     * Constructor
     */
    public JbAktie(String Name, int WKN, double AktKurs, double MinKurs, double MaxKurs, double Volumen) {
	createJbAktie(Name, WKN, AktKurs, MinKurs, MaxKurs, Volumen);
    }

    /**
     * Updates the members
     */
    public void createJbAktie(String Name, int WKN, double AktKurs, double MinKurs, double MaxKurs, double Volumen) {
	this.Name = Name;
	this.WKN = WKN;
	this.AktKurs = AktKurs;
	this.MinKurs = MinKurs;
	this.MaxKurs = MaxKurs;
	this.Volumen = Volumen;
    }

    public String getName() {
	return Name;
    }

    public int getWKN() {
	return WKN;
    }

    public double getAktKurs() {
	return AktKurs;
    }

    public double getMinKurs() {
	return MinKurs;
    }

    public double getMaxKurs() {
	return MaxKurs;
    }

    public double getVolumen() {
	return Volumen;
    }

}
