package Jbroker;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

import java.sql.*;

/**
 * View Dialog for the best Aktien
 * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
 */
public class JbBestDialog extends JFrame
{
    private int depotID;
    private int kundeID;
    private int kontoID;
    private double steigerung = 0;

    private JLabel wertProzentLabel;
    private JLabel wertEURLabel;
    private JLabel firmaProzentLabel;
    private JLabel firmaEURLabel;

    private int anzahlAktien;
    private HashMap myAktienHM;
    private HashMap gekaufteAktienHM;

/**
 * Constructor
 */
    public JbBestDialog(int kundeID, int depotID, int kontoID) {
	super("Maximale Wertsteigerung");
	this.kundeID = kundeID;
	this.depotID = depotID;
	this.kontoID = kontoID;

	init();
	createDialog();
    }

    /**
     * Set up the dialog
     */
    private void createDialog() {
	getContentPane().setLayout(new GridLayout(5, 2));

	getContentPane().add(new JLabel("Grsste prozentuale Wertsteigerung  "));
	getContentPane().add(wertProzentLabel = new JLabel("0"));

	getContentPane().add(new JLabel("Grsste Wertsteigerung pro Aktie (EUR / DM)  "));
	getContentPane().add(wertEURLabel = new JLabel("0"));

	getContentPane().add(new JLabel("Grsste prozentuale Wertsteigerung aller Zeiten  "));
	getContentPane().add(firmaProzentLabel = new JLabel("0"));

	getContentPane().add(new JLabel("Grsste Wertsteigerung aller Zeiten (EUR / DM)  "));
	getContentPane().add(firmaEURLabel = new JLabel("0"));

	// groesste Wertsteigerung des Aktien des Kundes
	double sumKauf = 0;
	double sumAkt = 0;
	int anzahl = 0;
	int wkn = -1;
	int maxEURWKN=0, maxProzentWKN=0;
	double maxGewinEUR = 0.0;
	double maxGewinProzent = 0.0;
	boolean firstTime = true;
	for (int row = 0; row < gekaufteAktienHM.size(); row++) {
	    JbGekaufteAktie currentAktie = (JbGekaufteAktie)gekaufteAktienHM.get(new Integer(row));
	    if (row==0)
		wkn = currentAktie.wkn;
	    if (currentAktie.wkn == wkn) {
		anzahl += currentAktie.kaufAnzahl;
		sumKauf += currentAktie.kaufKurs*currentAktie.kaufAnzahl;
		sumAkt +=  JbSQL.getAktieKurs(currentAktie.wkn)*currentAktie.kaufAnzahl;
	    } else {
		if (firstTime) {
		    maxGewinEUR = (sumAkt-sumKauf)/anzahl;
		    maxGewinProzent = (sumAkt-sumKauf)/sumKauf*100.0;
		    maxEURWKN = wkn;
		    maxProzentWKN = wkn;
		    firstTime = false;
		}
		if (maxGewinEUR < (sumAkt-sumKauf)/anzahl) {
		    maxGewinEUR = (sumAkt-sumKauf)/anzahl;
		    maxEURWKN = wkn;
		}
		if (maxGewinProzent < (sumAkt-sumKauf)/sumKauf*100.0 ) {
		    maxGewinProzent = (sumAkt-sumKauf)/sumKauf*100.0;
		    maxProzentWKN = wkn;
		}
		anzahl =currentAktie.kaufAnzahl;
		sumKauf = currentAktie.kaufKurs*currentAktie.kaufAnzahl;
		sumAkt =  JbSQL.getAktieKurs(currentAktie.wkn)*currentAktie.kaufAnzahl;
		wkn = currentAktie.wkn;
	    }
	}
	if(gekaufteAktienHM.size()>0){
	    wertEURLabel.setText(JbDefinition.betragEUR_DM(new Double(maxGewinEUR).toString())+", "+JbSQL.getAktieName(maxEURWKN));
	    wertProzentLabel.setText(JbDefinition.sprintf(maxGewinProzent, 3)+", "+JbSQL.getAktieName(maxProzentWKN));
	}

	// groesste Wertsteigerung des Aktien seit Eroefnung der Firma
	gekaufteAktienHM = JbSQL.getAktienHM();
	maxGewinEUR = 0.0;
	maxGewinProzent = 0.0;
	firstTime = true;
	for (int row = 0; row < gekaufteAktienHM.size(); row++) {
	    JbAktie currentAktie = (JbAktie)gekaufteAktienHM.get(new Integer(row));
	    double oldKurs = JbSQL.getAktieOldKurs(currentAktie.getWKN());
	    if (row == 0) {
		maxGewinProzent = (currentAktie.getAktKurs() - oldKurs)/oldKurs*100;
		maxGewinEUR = currentAktie.getAktKurs() - oldKurs;
		maxEURWKN = wkn;
		maxProzentWKN = wkn;
	    } else {
		if (maxGewinProzent < (currentAktie.getAktKurs() - oldKurs)/oldKurs*100){
		    maxGewinProzent = (currentAktie.getAktKurs() - oldKurs)/oldKurs*100;
		    maxProzentWKN = wkn;
		}
		if (maxGewinEUR < currentAktie.getAktKurs() - oldKurs){
		    maxGewinEUR = currentAktie.getAktKurs() - oldKurs;
		    maxEURWKN = wkn;
		}
	    }
	}

	if(gekaufteAktienHM.size()>0){
	    firmaEURLabel.setText(JbDefinition.betragEUR_DM(new Double(maxGewinEUR).toString())+", "+JbSQL.getAktieName(maxEURWKN));
	    firmaProzentLabel.setText(JbDefinition.sprintf(maxGewinProzent, 3)+", "+JbSQL.getAktieName(maxProzentWKN));
	}

	JButton okButton = new JButton("Na gut");
	okButton.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    setVisible(false);
		    dispose();
   		}});
	getContentPane().add(okButton);
    }

    /**
     * Init the dialog
     */
    private void init() {
	myAktienHM= new HashMap();
	gekaufteAktienHM = new HashMap();
	anzahlAktien = 0;

	try { // read and sum the Anzahl of the Aktien
	    ResultSet Res = JbSQL.query("select wkn, anzahl from DEPOTINHALT where (depotID="+depotID+")");
	    while(Res.next()){
		JbGekaufteAktie aux = new JbGekaufteAktie();
		aux.wkn = Integer.parseInt(Res.getString(1).trim());
		aux.kaufAnzahl = Integer.parseInt(Res.getString(2).trim());
		myAktienHM.put(new Integer(anzahlAktien), aux);
		anzahlAktien++;
	    }
	    for (int i=0;i<anzahlAktien;i++) {
		Res = JbSQL.query("select NVL(sum(anzahl), 0) from handel where (kID="+kundeID+" and wkn="+
				  ((JbGekaufteAktie)(myAktienHM.get(new Integer(i)))).wkn+" and anzahl<0)");
		int soldAktien = 0;
		if (Res.next())
		    soldAktien = Integer.parseInt(Res.getString(1).trim());

		// search Orders for current KundeID and anzahl>0
		Res = JbSQL.query("select TO_CHAR(Datum,\'DD-MON-YYYY\'), Kurs, Anzahl from HANDEL where (kID="+kundeID+
				  " and wkn="+((JbGekaufteAktie)(myAktienHM.get(new Integer(i)))).wkn+
				  " and anzahl>0) order by HandelId");
		while (Res.next()) {
		    JbGekaufteAktie aux = new JbGekaufteAktie(((JbGekaufteAktie)(myAktienHM.get(new Integer(i)))).wkn,
							      Res.getString(1).trim(), 
							      Double.parseDouble(Res.getString(2).trim()), 
							      Integer.parseInt(Res.getString(3).trim()));
		    if (soldAktien < 0)
			soldAktien += aux.kaufAnzahl;
		    if (soldAktien > 0) {
			aux.kaufAnzahl = soldAktien;
			soldAktien = 0;
		    }
		    if (soldAktien == 0)
			addToList(aux);
		}
	    }
	} catch (Exception ex) {ex.printStackTrace ();}
    }
    /**
     * Add an Aktie to the HashMap
     */
    private void addToList(JbGekaufteAktie aktie) {
	boolean appendAktie = true;
	int aux = gekaufteAktienHM.size();
	for (int i = 0; i < aux; i++)
	    if (((JbGekaufteAktie)gekaufteAktienHM.get(new Integer(i))).sumIfIdentical(aktie))
		appendAktie = false;

	if (appendAktie)
	    gekaufteAktienHM.put(new Integer(aux), aktie);
    }
}
