package Jbroker;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

import java.sql.*;

/**
 * Chart Dialog
 * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
 */
public class JbChartDialog extends JFrame
{
    private final String noComparation = "Keinem";

    private JTextField avgEdit = new JTextField(3);
    private JButton quitButton;
    private JComboBox wknCombo;
    private JComboBox wknCompareToCombo;
    private JComboBox monthPeriodCombo;
    private JPanel southPanel = new JPanel();
    private JbChart chart = new JbChart();
    private HashMap aktienHM;

/**
 * Constructor
 */
     public JbChartDialog(String title) {
	super(title);

	getContentPane().setLayout(new BorderLayout());

	southPanel.setLayout(new GridLayout(4, 2));
	JPanel south1Panel = new JPanel();
	south1Panel.setLayout(new BorderLayout());
	south1Panel.add(quitButton = new JButton("... und Tschss!"), BorderLayout.WEST);
	quitButton.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    closeChartDialog();
    		}});

	south1Panel.add(new JLabel("Aktie: "), BorderLayout.EAST);

	createWKNCombo();
	southPanel.add(south1Panel);
	southPanel.add(wknCombo);

	southPanel.add(new JLabel("Durchschnitt auf (Tage): "));
	southPanel.add(avgEdit);
	avgEdit.setText(new Integer(chart.getAvgOver()).toString());
	avgEdit.selectAll();
	avgEdit.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    int aux;
		    try{
			aux = new Integer(avgEdit.getText()).intValue();
		    }catch(Exception ex){aux=0;}
		    
		    chart.setAvgOver(aux);
		    avgEdit.setText(new Integer(chart.getAvgOver()).toString());
		    avgEdit.selectAll();
    		}});

	southPanel.add(new JLabel("Vergleichen mit: "));
	southPanel.add(wknCompareToCombo);

	southPanel.add(new JLabel("Zeigen die letzten "));
	monthPeriodCombo = new JComboBox();
	monthPeriodCombo.addItem("1 Monat");
	monthPeriodCombo.addItem("3 Monate");
	monthPeriodCombo.addItem("6 Monate");
	monthPeriodCombo.addItem("9 Monate");
	monthPeriodCombo.addItem("12 Monate");
	monthPeriodCombo.addItem("... seit der Begrndung der Firma");
	southPanel.add(monthPeriodCombo);
	monthPeriodCombo.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    chart.setPeriod(monthPeriodCombo.getSelectedIndex()==0 ? 1: monthPeriodCombo.getSelectedIndex()*3);
    		}});

	getContentPane().add(southPanel, BorderLayout.SOUTH);
	getContentPane().add(chart, BorderLayout.CENTER);
	pack();
    }

    /**
     * Creates a ComboBox with all the Aktien from the data base
     */
    public void createWKNCombo() {
	aktienHM = JbSQL.createAktienHashMap();
	aktienHM.put(new String(noComparation), new JbAktie());

    	wknCombo = JbSQL.createAktienJComboBox();
    	wknCombo.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    chart.setWKN(((JbAktie)(aktienHM.get((String)(wknCombo.getSelectedItem())))).getWKN());
    		}});

    	wknCompareToCombo = JbSQL.createAktienJComboBox();
    	wknCompareToCombo.insertItemAt(noComparation, 0);
    	wknCompareToCombo.setSelectedItem(noComparation);
    	wknCompareToCombo.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    chart.setCompareToWKN(((JbAktie)(aktienHM.get((String)(wknCompareToCombo.getSelectedItem())))).getWKN());
		    if (chart.getCompareToWKN() == 0)
			wknCompareToCombo.setSelectedItem(noComparation);
    		}});

	chart.setWKN(((JbAktie)(aktienHM.get((String)(wknCombo.getSelectedItem())))).getWKN());
    }

    /**
     * Closes the window
     */
    private void closeChartDialog() {
	setVisible(false);
	dispose();
    }

}
