package Jbroker;

import java.io.*;
import java.sql.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Credit limit negociation Dialog
 * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
 */
public class JbCreditLimitDialog extends JFrame{

    private double limit;
    private int kontoID;
    private int depotID;
    private JLabel kreditLimit;
    private JLabel kreditLimitEUR;
    private JTextField beantragen;
    private JButton okButton;
    private JButton cancelButton;

/**
 * Constructor
 */
    public JbCreditLimitDialog(int kontoID, int depotID) {
	super("Kreditlimit");

	this.kontoID = kontoID;
	this.depotID = depotID;

	getContentPane().setLayout(new GridLayout(4, 2));
	getContentPane().add(new JLabel("Kreditramen (% Depot)  "));
	getContentPane().add(kreditLimit = new JLabel("0"));

	getContentPane().add(new JLabel("Kreditramen (EUR / DM)  "));
	getContentPane().add(kreditLimitEUR = new JLabel("0"));

	getContentPane().add(new JLabel("Beantragen (% Depot)   "));
	getContentPane().add(beantragen = new JTextField(5));
	beantragen.setText("50");
	beantragen.selectAll();

	double limit = JbSQL.getKundeKreditLimit_EUR(depotID, kontoID);
	kreditLimitEUR.setText(JbDefinition.betragEUR_DM(new Double(limit).toString()));
	limit = JbSQL.getKundeKreditLimit_prozent(kontoID);
	kreditLimit.setText(JbDefinition.sprintf(limit,3));
	beantragen.setText(JbDefinition.sprintf(limit,3));
	beantragen.selectAll();

	getContentPane().add(okButton = new JButton("Ich bestehe darauf!"));
	okButton.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    checkNewLimit();
    		}});

	getContentPane().add(cancelButton = new JButton("Ich gebe auf"));
	cancelButton.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    setVisible(false);
		    dispose();
    		}});
    }

/**
 * Check whether the new limit is acceptable or not ( RANDOM emulation )
 */
    private void checkNewLimit() {
	double oldLimit = Double.parseDouble(kreditLimit.getText().trim());
	limit = Double.parseDouble(beantragen.getText());

	if (Math.random()*(limit/oldLimit) < 0.4) {
	    JbSQL.query("update KKONTO set IndivKredit=\'"+limit+"\' where kontoID=\'"+kontoID+"\'");
	    setVisible(false);
	    dispose();
	    return;
	}
	Object[] options = { "Zur Kenntnis genommen"};
	JOptionPane.showOptionDialog(this,
				     "Der Antrag zur nderung des Kreditlimits"+
				     "\nwurde von der Verwaltung abgelehnt!",
				     "Achtung", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE,
				     null, options, options[0]);
    }
}
