package Jbroker;

import java.util.*;

/**
 * This abstract class is used for definitions.
 * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
 */
public abstract class JbDefinition
{
    public static final String HomeDir = new String(System.getProperty("user.home")+"/.Jbroker");
    public static final String ImagesDir = HomeDir + "/images";
    public static final String AuthentificationImage = ImagesDir + "/auth.jpg";
    public static final String AddNewUserImage = ImagesDir + "/adduser.jpg";
    public static final Calendar setFoundationDate(Calendar cal) {
	if (cal == null)
	    cal = Calendar.getInstance();
    	cal.set(1999, 2, 5); // Grounding day of the MakeMoney (year, month, day)
    	return cal;
    }
    public static final String betragEUR_DM(String betragEUR) {
	double tmpDM = Double.parseDouble(betragEUR.trim());
	return new String(sprintf(tmpDM, 3)+" / "+sprintf(tmpDM * 1.9558, 3));
    }

    /*
     * Formats the double d to an String with dec decimals
     */
    public static final String sprintf(double d, int dec) {
	String auxs=new String().valueOf(d);
	int ind=auxs.indexOf('.');
	if (ind+dec <= auxs.length())
	    auxs=auxs.substring(0,ind+dec);
	return auxs;
    }

    /*
     * generates a new Stock value based upon the old one and WKN
     */
    public static final double newRandomKurs(Double oldKurs, Integer WKN) {
	return  oldKurs.doubleValue()+2.7*Math.random()*Math.sin( oldKurs.doubleValue() + 5.0*Math.sin(257/Math.random()*10.0+0.23*(Math.random()*(WKN.intValue()%10))*Math.random())+2.5*Math.random());
    }

}
