package Jbroker;

/**
 * A structure to handle gekaufte Aktien.
 * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
 */
public class JbGekaufteAktie
{
    public int wkn;
    public String kaufDatum;
    public double kaufKurs;
    public int kaufAnzahl;

    /**
     * Empty contructor
     */
    public JbGekaufteAktie() {
	wkn = -1;
	kaufDatum = new String();
	kaufKurs = 0;
	kaufAnzahl = -1;
    }

    /**
     * Contructor
     */
    public JbGekaufteAktie(int wkn, String kaufDatum, double kaufKurs, int kaufAnzahl) {
	this.wkn = wkn;
	this.kaufDatum = kaufDatum;
	this.kaufKurs = kaufKurs;
	this.kaufAnzahl = kaufAnzahl;
    }

    /**
     * @returns true if the aktie has same kaufDatum and kaufKurs with this
     */
    public boolean sumIfIdentical(JbGekaufteAktie aktie) {
	if ((this.wkn == aktie.wkn) &&
	    (this.kaufDatum.equals(aktie.kaufDatum)) &&
	    (this.kaufKurs == aktie.kaufKurs))
	    {
		this.kaufAnzahl += aktie.kaufAnzahl;
		return true;
	    }
	return false;
    }
}
