package Jbroker;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

import java.sql.*;

/**
 * Display the balance of the client's account
 * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
 */
public class JbKontoStand extends JFrame
{
    private JLabel kontoStandLabel;
    private JLabel depotStandLabel;
    private JLabel kreditLimitLabel;
    private JLabel kreditLimitEURLabel;
    private int kontoID;
    private int depotID;

/**
 * Constructor
 */
    public JbKontoStand(int kontoID, int depotID) {
	super("Kontoinhalt");

	this.kontoID = kontoID;
	this.depotID = depotID;

	createDialog();
    }

/**
 * Set up the Dialog
 */
    private void createDialog() {
	getContentPane().setLayout(new GridLayout(5, 2));

	getContentPane().add(new JLabel("Kontostand (EUR / DM)  "));
	getContentPane().add(kontoStandLabel = new JLabel("0/0"));

	getContentPane().add(new JLabel("Depotstand (EUR / DM)  "));
	getContentPane().add(depotStandLabel = new JLabel("0/0"));

	getContentPane().add(new JLabel("Kreditlimit (% Depot)"));
	getContentPane().add(kreditLimitLabel = new JLabel("0"));

	getContentPane().add(new JLabel("Kreditlimit (EUR / DM)"));
	getContentPane().add(kreditLimitEURLabel = new JLabel("0"));

	double betrag = JbSQL.getKundeKontoStand(kontoID);
	kontoStandLabel.setText(JbDefinition.betragEUR_DM(new Double(betrag).toString()));

	double kredit = JbSQL.getKundeKreditLimit_EUR(depotID, kontoID);
	kreditLimitEURLabel.setText(JbDefinition.betragEUR_DM(new Double(kredit).toString()));

	kredit = JbSQL.getKundeKreditLimit_prozent(kontoID);
	kreditLimitLabel.setText(new Double(kredit).toString());

	double depot = JbSQL.getKundeAktienWert(depotID);
	depotStandLabel.setText(JbDefinition.betragEUR_DM(new Double(depot).toString()));

	JButton okButton = new JButton("Na gut");
	okButton.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    setVisible(false);
		    dispose();
   		}});
	getContentPane().add(okButton);

    }

}
