package Jbroker;

import java.sql.*; 
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.util.*;

/**
 * Auxiliary class for the KURS database generation
 * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
 */
public class JbKursSimulator{

/**
 * Main subroutine
 */
    public static void main(String[] argv) {

	JbSQL.open();

	Calendar calendar = Calendar.getInstance();
	java.util.Date today = calendar.getTime();
	int wknCount = 0;

	ResultSet res = JbSQL.query("select count(*) from AKTIE");
	try {
	    while (res.next())
		wknCount = res.getInt(1);
	}catch(SQLException e){e.printStackTrace ();};

	int[] wkn = new int[wknCount];
	double[] kursValue = new double[wknCount];

	res = JbSQL.query("select WKN, AktKurs from AKTIE");
	try {
	    int i=0;
	    while (res.next()) {
		wkn[i] = new Integer(res.getString(1).trim()).intValue();
		kursValue[i] = res.getDouble(2);
		i++;
	    }
	}catch(SQLException e){e.printStackTrace ();};


	for(int i=0;i<wknCount;i++) {

	    System.out.println("Generating archive data for WKN="+wkn[i]);

	    JbSQL.query("delete kurs where (wkn="+wkn[i]+")");

	    JbDefinition.setFoundationDate(calendar); // set date to the begining of the Firma
	    int t=0;
	    for (;calendar.getTime().before(today);calendar.add(Calendar.DATE, 1)) {
		//  	    kursValue += 10.0-Math.random()*4.0;

				// MISTO!!!
		//  	    kursValue += kursValue*(Math.random()*0.01-0.003);

		//	    kursValue =Math.sin(t/5.0);
		//	    kursValue =Math.log(t);
		// 	    kursValue +=Math.log(kursValue+Math.sin(1/12*t+2.3)-Math.sin(1/3*t+0.042)*Math.sin(1/2*t+0.031)+0.5*Math.sin(7*t+0.17));

		// BESTIAL !!!!!!!!!!
		kursValue[i] +=2.7*Math.random()*Math.sin(kursValue[i] + 5.0*Math.sin(t/Math.random()*10.0+0.23*(Math.random()*(wkn[i]%10))*Math.random())+2.5*Math.random());
		if (kursValue[i] < 0)
		    kursValue[i] = 2.7*Math.random();


		JbSQL.query("insert into kurs values (\'"+
			    JbSQL.toSQLDate(calendar)+"\',"+kursValue[i]+", "+wkn[i]+")");
		t++;
	    }
	    JbSQL.query("update AKTIE set AktKurs="+kursValue[i]+" where WKN="+wkn[i]);
	} // for

	System.out.println(wknCount+" WKN values successfully updated!");
	JbSQL.close();
    }

}

