package Jbroker;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;

import java.util.*;
import java.io.*;
import java.lang.*;
import java.sql.*;
import java.util.*;
import java.net.* ;

/**
 * Stock gain table window
  * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
*/
public class JbStockGainTable extends JFrame {
    private Object[][] tableData;
    private JTable table;
    private int depotID, kundeID;
    private int anzahlAktien;
    private HashMap myAktienHM;
    private HashMap gekaufteAktienHM;

    private final String[] columnNames =
	new String[]{"WKN","Name","Kauf Datum","Kauf Kurs","Aktuelle Kurs", "Menge"};

/**
 * Constructor
 */
    public JbStockGainTable(int kundeID, int depotID) {
	super("Gegenueberstellung des Aktiens Kauf- und aktueller Preis");
	this.kundeID = kundeID;
	this.depotID = depotID;
	createTable();
	pack();
    }

/**
 * Set up the table
 */
    public void createTable() {

	update();
	table = new JTable(tableData, columnNames);
	table.setPreferredScrollableViewportSize(new Dimension(600, 70));

	table.addMouseListener(new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
		}
	    });

	//Create the scroll pane and add the table to it. 
	JScrollPane scrollPane = new JScrollPane(table);

	//Add the scroll pane to this window.
	getContentPane().add(scrollPane, BorderLayout.CENTER);
    }

/**
 * Reads the data from the database
 */
    public void update() {

	myAktienHM= new HashMap();
	gekaufteAktienHM = new HashMap();
	anzahlAktien = 0;

	try { // read and sum the Anzahl of the Aktien
	    ResultSet Res = JbSQL.query("select wkn, anzahl from DEPOTINHALT where (depotID="+depotID+")");
	    while(Res.next()){
		JbGekaufteAktie aux = new JbGekaufteAktie();
		aux.wkn = Integer.parseInt(Res.getString(1).trim());
		aux.kaufAnzahl = Integer.parseInt(Res.getString(2).trim());
	        myAktienHM.put(new Integer(anzahlAktien), aux);
		anzahlAktien++;
	    }
	    for (int i=0;i<anzahlAktien;i++) {
		Res = JbSQL.query("select NVL(sum(anzahl), 0) from handel where (kID="+kundeID+" and wkn="+
				  ((JbGekaufteAktie)(myAktienHM.get(new Integer(i)))).wkn+" and anzahl<0)");
		int soldAktien = 0;
		if (Res.next()) 
		    soldAktien = Integer.parseInt(Res.getString(1).trim());

		// search Orders for current KundeID and anzahl>0
		Res = JbSQL.query("select TO_CHAR(Datum,\'DD-MON-YYYY\'), Kurs, Anzahl from HANDEL where (kID="+kundeID+
				  " and wkn="+((JbGekaufteAktie)(myAktienHM.get(new Integer(i)))).wkn+
				  " and anzahl>0) order by HandelId");
		while (Res.next()) {
		    JbGekaufteAktie aux = new JbGekaufteAktie(((JbGekaufteAktie)(myAktienHM.get(new Integer(i)))).wkn,
							      Res.getString(1).trim(), 
							      Double.parseDouble(Res.getString(2).trim()), 
							      Integer.parseInt(Res.getString(3).trim()));
		    if (soldAktien < 0)
			soldAktien += aux.kaufAnzahl;
		    if (soldAktien > 0) {
			aux.kaufAnzahl = soldAktien;
			soldAktien = 0;
		    }
		    if (soldAktien == 0)
			addToList(aux);
		}
	    }
	} catch (Exception e) {e.printStackTrace ();}

	tableData = new Object[gekaufteAktienHM.size()][columnNames.length];

	for (int row = 0; row < gekaufteAktienHM.size(); row++) {
	    JbGekaufteAktie currentAktie = (JbGekaufteAktie)gekaufteAktienHM.get(new Integer(row));
	    tableData[row][0] = new Integer(currentAktie.wkn);
	    tableData[row][1] = JbSQL.getAktieName(currentAktie.wkn);
	    tableData[row][2] = currentAktie.kaufDatum;
	    tableData[row][3] = new Double(currentAktie.kaufKurs);
	    tableData[row][4] = new Double(JbSQL.getAktieKurs(currentAktie.wkn));
	    tableData[row][5] = new Integer(currentAktie.kaufAnzahl);
	}
    }

    /**
     * Adds Aktie to the HashMap
     */
    private void addToList(JbGekaufteAktie aktie) {
	boolean appendAktie = true;
	int aux = gekaufteAktienHM.size();
	for (int i = 0; i < aux; i++)
	    if (((JbGekaufteAktie)gekaufteAktienHM.get(new Integer(i))).sumIfIdentical(aktie))
		appendAktie = false;

	if (appendAktie) 
	    gekaufteAktienHM.put(new Integer(aux), aktie);

    }
}
