package Jbroker;

import javax.swing.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;

import java.util.*;
import java.io.*;
import java.lang.*;
import java.sql.*;
import java.util.*;
import java.net.* ;

/**
 * Base table class used for viewing the query results applied on the database
  * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
*/
public class JbTable extends JFrame {

    private Object[][] tableData;
    private JTable table;
    private String queryCommand;
    private int rows, columns;

/**
 * Empty constructor
 */
    public JbTable() {
	super("JbTable");
	createTable(new String("select WKN, Name, AktKurs, MaxKurs, MinKurs, Volumen from aktie"),
		    new String[]{"WKN","Name","AktKurs","MaxKurs","MinKurs","Volumen"});
	pack();
    }

/**
 * Constructor
 */
    public JbTable(String newQuery, String[] columnNames) {
	super("JbTable");
	createTable(newQuery, columnNames);
	pack();
    }

/**
 * Constructor
 */
    public JbTable(String caption, String newQuery, String[] columnNames) {
	super(caption);
	createTable(newQuery, columnNames);
	pack();
    }

/**
 * Generate the table contents from database
 */
    public void createTable(String queryCommand, String[] columnNames) {

	this.queryCommand = queryCommand;

	columns = columnNames.length;
	update(false);

	tableData = new Object[rows][columns];
	for (int i=0;i<rows;i++)
	    for (int j=0;j<columns;j++)
		tableData[i][j] = new String();

	table = new JTable(tableData, columnNames);
	table.setPreferredScrollableViewportSize(new Dimension(500, 70));

	table.addMouseListener(new MouseAdapter() {
		public void mouseClicked(MouseEvent e) {
		}
	    });

	update(true);

	//Create the scroll pane and add the table to it. 
	JScrollPane scrollPane = new JScrollPane(table);

	//Add the scroll pane to this window.
	getContentPane().add(scrollPane, BorderLayout.CENTER);
    }

/**
 * Internal use method
 */
    private void update(boolean actionOn) {
	update(queryCommand, actionOn);
    }

/**
 * Internal use method
 */
    private void update(String newQuery, boolean actionOn) {
	queryCommand = newQuery;
	try
	    {
		ResultSet Res = JbSQL.query(queryCommand);
		int row=0;
		while(Res.next()){
		    if (actionOn)
			for(int i=0;i<columns;i++)
			    table.setValueAt(Res.getString(i+1),row,i);
		    row++;
		}
		rows = row;
	    }
	catch (Exception e)
	    {
		e.printStackTrace ();
	    }
    }
}
