package Jbroker;

import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;

import java.sql.*;

/**
 * Gain growth dialog
 * @version Java Fast Broker 1.0
 * @author Valentin Zaharescu & Bogdan Stanca<br>
 * Copyright (c)2000 all rights reserved<br>
 */
public class JbWertSteigerungDialog extends JFrame
{
    private JComboBox comboAktie;
    private int depotID;
    private int kundeID;
    private int kontoID;
    private double steigerung = 0;
    private HashMap aktienHM;

    private JLabel wertProzentLabel;
    private JLabel wertEURLabel;
    private JLabel wertTotalEURLabel;
    private JLabel totalEURLabel;
    private JLabel totalProzentLabel;

    private int anzahlAktien;
    private HashMap myAktienHM;
    private HashMap gekaufteAktienHM;

/**
 * Constructor
 */
    public JbWertSteigerungDialog(int kundeID, int depotID, int kontoID) {
	super("Wertsteigerung seit kauf");
	this.kundeID = kundeID;
	this.depotID = depotID;
	this.kontoID = kontoID;

	init();
	createDialog();
    }

/**
 * Set up the dialog
 */
    private void createDialog() {
	comboAktie = JbSQL.createOwnAktienJComboBox(depotID);
	aktienHM = JbSQL.createOwnAktienHashMap(depotID);

	getContentPane().setLayout(new GridLayout(7, 2));

	getContentPane().add(new JLabel("Aktie"));
	getContentPane().add(comboAktie);

	getContentPane().add(new JLabel("Prozentuale Wertsteigerung  "));
	getContentPane().add(wertProzentLabel = new JLabel("0"));

	getContentPane().add(new JLabel("Wertsteigerung pro Aktie (EUR / DM)  "));
	getContentPane().add(wertEURLabel = new JLabel("0"));

	getContentPane().add(new JLabel("Gesamtgewin (EUR / DM)  "));
	getContentPane().add(wertTotalEURLabel = new JLabel("0"));

	getContentPane().add(new JLabel("Gesamtgewin pro Depot (EUR / DM)  "));
	getContentPane().add(totalEURLabel = new JLabel("0"));

	getContentPane().add(new JLabel("Prozentuele Gesamtgewin pro Depot  "));
	getContentPane().add(totalProzentLabel = new JLabel("0"));

	double sumKauf1 = 0;
	double sumAkt1 = 0;
	for (int row = 0; row < gekaufteAktienHM.size(); row++) {
	    JbGekaufteAktie currentAktie = (JbGekaufteAktie)gekaufteAktienHM.get(new Integer(row));
	    sumKauf1 += currentAktie.kaufKurs*currentAktie.kaufAnzahl;
	    sumAkt1 +=  JbSQL.getAktieKurs(currentAktie.wkn)*currentAktie.kaufAnzahl;
	}
	totalEURLabel.setText(JbDefinition.betragEUR_DM(new Double(sumAkt1-sumKauf1).toString()));
	if (sumKauf1 == 0)
	    totalProzentLabel.setText(JbDefinition.betragEUR_DM(new Double(0.0).toString()));
	else
	    totalProzentLabel.setText(JbDefinition.sprintf((sumAkt1-sumKauf1)/sumKauf1*100.0, 3));

	comboAktie.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    double sumKauf = 0;
		    double sumAkt = 0;
		    int anzahl = 0;
		    int wkn = ((JbAktie)(aktienHM.get((String)(comboAktie.getSelectedItem())))).getWKN();

		    for (int row = 0; row < gekaufteAktienHM.size(); row++) {
			JbGekaufteAktie currentAktie = (JbGekaufteAktie)gekaufteAktienHM.get(new Integer(row));
			if (currentAktie.wkn == wkn) {
			    anzahl += currentAktie.kaufAnzahl;
			    sumKauf += currentAktie.kaufKurs*currentAktie.kaufAnzahl;
			    sumAkt +=  JbSQL.getAktieKurs(currentAktie.wkn)*currentAktie.kaufAnzahl;
			}
		    }
		    wertEURLabel.setText(JbDefinition.betragEUR_DM(new Double((sumAkt-sumKauf)/anzahl).toString()));
		    wertTotalEURLabel.setText(JbDefinition.betragEUR_DM(new Double(sumAkt-sumKauf).toString()));
		    wertProzentLabel.setText(JbDefinition.sprintf((sumAkt-sumKauf)/sumKauf*100.0, 3));
		}});
	comboAktie.setSelectedIndex(0);

	JButton okButton = new JButton("Na gut!");
	okButton.addActionListener(new ActionListener() {
    		public void actionPerformed(ActionEvent e){
		    setVisible(false);
		    dispose();
   		}});
	getContentPane().add(okButton);
    }

/**
 * Init the dialog
 */
    private void init() {
	myAktienHM= new HashMap();
	gekaufteAktienHM = new HashMap();
	anzahlAktien = 0;

	try { // read and sum the Anzahl of the Aktien
	    ResultSet Res = JbSQL.query("select wkn, anzahl from DEPOTINHALT where (depotID="+depotID+")");
	    while(Res.next()){
		JbGekaufteAktie aux = new JbGekaufteAktie();
		aux.wkn = Integer.parseInt(Res.getString(1).trim());
		aux.kaufAnzahl = Integer.parseInt(Res.getString(2).trim());
		myAktienHM.put(new Integer(anzahlAktien), aux);
		anzahlAktien++;
	    }
	    for (int i=0;i<anzahlAktien;i++) {
		Res = JbSQL.query("select NVL(sum(anzahl), 0) from handel where (kID="+kundeID+" and wkn="+
				  ((JbGekaufteAktie)(myAktienHM.get(new Integer(i)))).wkn+" and anzahl<0)");
		int soldAktien = 0;
		if (Res.next())
		    soldAktien = Integer.parseInt(Res.getString(1).trim());

		// search Orders for current KundeID and anzahl>0
		Res = JbSQL.query("select TO_CHAR(Datum,\'DD-MON-YYYY\'), Kurs, Anzahl from HANDEL where (kID="+kundeID+
				  " and wkn="+((JbGekaufteAktie)(myAktienHM.get(new Integer(i)))).wkn+
				  " and anzahl>0) order by HandelId");
		while (Res.next()) {
		    JbGekaufteAktie aux = new JbGekaufteAktie(((JbGekaufteAktie)(myAktienHM.get(new Integer(i)))).wkn,
							      Res.getString(1).trim(), 
							      Double.parseDouble(Res.getString(2).trim()), 
							      Integer.parseInt(Res.getString(3).trim()));
		    if (soldAktien < 0)
			soldAktien += aux.kaufAnzahl;
		    if (soldAktien > 0) {
			aux.kaufAnzahl = soldAktien;
			soldAktien = 0;
		    }
		    if (soldAktien == 0)
			addToList(aux);
		}
	    }
	} catch (Exception ex) {ex.printStackTrace ();}
    }

/**
 * Add aktie to a HashMap
 */
    private void addToList(JbGekaufteAktie aktie) {
	boolean appendAktie = true;
	int aux = gekaufteAktienHM.size();
	for (int i = 0; i < aux; i++)
	    if (((JbGekaufteAktie)gekaufteAktienHM.get(new Integer(i))).sumIfIdentical(aktie))
		appendAktie = false;

	if (appendAktie)
	    gekaufteAktienHM.put(new Integer(aux), aktie);
    }
}
