CREATE TABLE KURS (
              Datum Date,
              Tageskurs Number(8,2), 
              WKN char(6),
              PRIMARY KEY(Datum,WKN),
              FOREIGN KEY(WKN) REFERENCES AKTIE (WKN)
          ); 

CREATE TABLE AKTIE (
              WKN char(6),
              Name varchar(30), 
              AktKurs Number(8,2),
              MaxKurs Number(8,2),
              MinKurs Number(8,2),
              Volumen Number(9,3),
              PRIMARY KEY(WKN)
          );

CREATE TABLE KUNDE (
              KID varchar(6),
              Name varchar(30), 
              Vorname varchar(30), 
              DepotID char(10),
              KontoID char(10),
              PRIMARY KEY(KID),
              FOREIGN KEY(DepotID) REFERENCES DEPOTKONTO (DepotID),
              FOREIGN KEY(KontoID) REFERENCES KKONTO (KontoID)
          );

CREATE TABLE HANDEL (
              WKN char(6),
              KID varchar(6), 
              HandelID int, 
              Datum Date,
              Kurs Number(8,2),
              Anzahl int,
              PRIMARY KEY(WKN,KID,HandelID),
              FOREIGN KEY(WKN) REFERENCES AKTIE (WKN),
              FOREIGN KEY(KID) REFERENCES KUNDE (KID)
          );

CREATE TABLE KKONTO(
              KontoID char(10),
              Betrag Number(8,2),
              IndivKredit Number(8,2),
              PRIMARY KEY(KontoID)
          );

CREATE TABLE DEPOTKONTO(
              DepotID char(10),
              AngelegtAm Date,
              PRIMARY KEY(DepotID)
          );

CREATE TABLE DEPOTINHALT(
              DepotID char(10),
              WKN char(6),
              Anzahl int,
              PRIMARY KEY(DepotID,WKN),
              FOREIGN KEY(WKN) REFERENCES AKTIE (WKN),
              FOREIGN KEY(DepotID) REFERENCES DEPOTKONTO (DepotID)
          );


